<?php
require_once (__FILE__ . "/../" . "include.php");

class ORMapperQueryWhere {

	var $queryWhere;

    function ORMapperQueryWhere() {
		$this->queryWhere = new QueryWhere();
    }
    
    function addAnd($whereObject) {
    		$queryWhere = $this->queryWhere;
    		$queryWhere->addAnd($whereObject->queryWhere);
    }
    
    function addOr($whereObject) {
    		$queryWhere = $this->queryWhere;
    		$queryWhere->addOr($whereObject->queryWhere);
    }
    
    function addEqualsAnd($fieldName, $value) {
    		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				$queryWhere->addStringEqualsAnd($fieldName, $value);
				break;
			case "t":
				$queryWhere->addTimestampEqualsAnd($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericEqualsAnd($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addEqualsOr($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				$queryWhere->addStringEqualsOr($fieldName, $value);
				break;
			case "t":
				$queryWhere->addTimestampEqualsOr($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericEqualsOr($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addLikeAnd($fieldName, $value) {
    		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				$queryWhere->addStringLikeAnd($fieldName, $value);
				break;
			case "t":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_WARNING);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_WARNING);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addLikeOr($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				$queryWhere->addStringLikeOr($fieldName, $value);
				break;
			case "t":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_ERROR);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_ERROR);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addGreaterAnd($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_ERROR);
				break;
			case "t":
				$queryWhere->addTimestampGreaterAnd($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericGreaterAnd($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addGreaterOr($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_WARNING);
				break;
			case "t":
				$queryWhere->addTimestampGreaterOr($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericGreaterOr($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addLessAnd($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_WARNING);
				break;
			case "t":
				$queryWhere->addTimestampLessAnd($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericLessAnd($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function addLessOr($fieldName, $value) {
		$queryWhere = $this->queryWhere;
		switch (FieldLibrary::getFieldTypeString($fieldName)) {
			case "s":
				trigger_error(ORMapperErrorMessages::faultQueryWhere(), E_USER_WARNING);
				break;
			case "t":
				$queryWhere->addTimestampLessOr($fieldName, $value);
				break;
			case "id":
			case "i":
			case "d":
			case "b":
			default:
				$queryWhere->addNumericLessOr($fieldName, $value);
				break;
		}
		$this->queryWhere = $queryWhere;
    }
    function getWhereQueryObject() {
    		return $this->queryWhere;
    }
}
?>